-- Initialize variables
local dbver="1";
local ver="2.02";
local xbarminver=2.00;
local n,i,f,b,c,XBARMOD,BARNAME;

XCustomBarData={ };

local XCUSTOMBAR_LOADED = false;
SLASH_XCUSTOMBAR1 = "/xcustombar";

-- Local cache of inventory
local XCustomBarInventoryCount={ };
local XCustomBarInventoryEquip={ };

local XCustomBarActionMenuData = {
-- When Left and right action modifiers are supported in Secure Frames, we can uncomment the lines and put the menus back
	{["text"]=XCUSTOMBAR_M1,["value"]=nil},
	{["text"]=XCUSTOMBAR_M2,["value"]="MS"},
--	{["text"]=XCUSTOMBAR_M2.." ("..XCUSTOMBAR_M10..")",["value"]="MSL"},
--	{["text"]=XCUSTOMBAR_M2.." ("..XCUSTOMBAR_M11..")",["value"]="MSR"},
	{["text"]=XCUSTOMBAR_M3,["value"]="MC"},
--	{["text"]=XCUSTOMBAR_M3.." ("..XCUSTOMBAR_M10..")",["value"]="MCL"},
--	{["text"]=XCUSTOMBAR_M3.." ("..XCUSTOMBAR_M11..")",["value"]="MCR"},
	{["text"]=XCUSTOMBAR_M4,["value"]="MA"},
--	{["text"]=XCUSTOMBAR_M4.." ("..XCUSTOMBAR_M10..")",["value"]="MAL"},
--	{["text"]=XCUSTOMBAR_M4.." ("..XCUSTOMBAR_M11..")",["value"]="MAR"},
	{["text"]=XCUSTOMBAR_M5,["value"]=nil},
	{["text"]=XCUSTOMBAR_M6,["value"]="F1"},
	{["text"]=XCUSTOMBAR_M7,["value"]="F2"},
	{["text"]=XCUSTOMBAR_M8,["value"]="F0"},
	{["text"]=XCUSTOMBAR_M9,["value"]=nil},
	{["text"]="1",["value"]="B1"},
	{["text"]="2",["value"]="B2"},
	{["text"]="3",["value"]="B3"},
	{["text"]="4",["value"]="B4"},
	{["text"]="5",["value"]="B5"},
	{["text"]=XCUSTOMBAR_M8,["value"]="B*"}
};

--==XCUSTOMBAR OPTIONS GUI==--

function XCustomBarOptionsGUI_OnLoad()
	local XBarNest=getfenv()["XCustomBarOptionsGUI"];
	XBarNest.name="XCustomBar";
	XBarNest.parent="XBar"; -- empty for now, i might nest it later.
	XBarNest.okay=nil;
	XBarNest.cancel=nil;
	XBarNest.defaults=nil;
	InterfaceOptions_AddCategory(XBarNest);
end

--==XCUSTOMBAR==--

function XCustomLoaderBar_OnLoad()
	if XBar_GetVersion ~= nil then
	if XBar_GetVersion() >= xbarminver then
		this:RegisterEvent("VARIABLES_LOADED");
		this:RegisterEvent("PLAYER_ENTERING_WORLD");

		this:RegisterEvent("BAG_UPDATE");

		SlashCmdList["XCUSTOMBAR"] = function(msg)
			XCustomBar_SlashHandler(string.lower(msg));
		end
	else
		DEFAULT_CHAT_FRAME:AddMessage(XCUSTOMBAR_MSG8..tostring(xbarminver)..XCUSTOMBAR_MSG9);
	end
	end
end

-- BAG_UPDATE events must be handled in one place to reduce latency
local UPDATINGINV = false;

function XCustomLoaderBar_OnEvent()
	local i,n,b,f,c,m;

	if (event == "VARIABLES_LOADED") then		
		-- Validate data
		if (XCustomBarData["nbars"]==nil) then
			DEFAULT_CHAT_FRAME:AddMessage(XCUSTOMBAR_MSG1);
			-- no data found, lets make it
			XCustomBarData = {
				["nbars"]=0,
				["bars"] = {},
			};
		end

		-- Instantiate bars
		n=XCustomBarData["nbars"];
		if (n==nil) then
			n=0;
		end

		-- Double check just in case XBar hasn't got this yet.
		XBar_BuildPlayerName();

		-- Loop to set up our bars
		for i=1,n do
			-- Retrieve and define object names
			BARNAME=XCustomBarData["bar"..tostring(i)];
			XBARMOD="XCustomBar"..BARNAME;

			b=XCustomBarData["bars"][BARNAME]["nbuttons"];

			--Default settings and other info about the mod if required
			if ((XBarModData[XBARMOD]==nil) and (b>0)) then
				XBarModData[XBARMOD]={
					----REQUIRED VALUES----
					["nbuttons"]=b,
					["dbver"]=dbver,
					["dhorizontal"]=true,
					["dhidebar"]=false,
					["dorder"]="az",
					["dscale"]=1,
					["dtooltips"]=true,
					["booktype"]=BOOKTYPE_SPELL,
					["enabled"]=true,
					["nchecks"]=0,
					["nsliders"]=0,
					["ftexint"]=nil,
					["foptioncb"]=nil,
					["fbuttoncb"]="XCustomBar_Button",
					["fbuttonid"]="XCustomBar_ButtonID",
				};
			end

			-- Instantiate Frames
			f=CreateFrame("Frame",XBARMOD,UIParent,"XBarTemplate");
			-- This entry will help us find the identity of the bar later
			if XBarFrameDB[XBARMOD] == nil then
				XBarFrameDB[XBARMOD]={};
			end
			XBarFrameDB[XBARMOD]["XCUSTOMBAR"]=BARNAME;
			f:SetScript("OnEvent",XCustomBar_OnEvent);

			-- Since we can't use the OnLoad event, we'll put the code here
			f:RegisterEvent("SPELLS_CHANGED");
			f:RegisterEvent("SPELL_UPDATE_COOLDOWN");
			f:RegisterEvent("PLAYER_ENTERING_WORLD");
			f:RegisterEvent("PLAYER_AURAS_CHANGED");
			f:RegisterEvent("UPDATE_MACROS");
			f:RegisterEvent("ACTIONBAR_UPDATE_USABLE");

			getfenv()[XBARMOD.."Spells"]={};
			for c=1,b do
				tinsert(getfenv()[XBARMOD.."Spells"],"+");
			end
		end
	elseif (event == "BAG_UPDATE") then
		-- We're updating in this frame to reduce calls to XCustomBarUpdateInventory()
		XCustomBarUpdateInventory();
		-- for each bar, send updates
		n=XCustomBarData["nbars"];
		if (n==nil) then
			n=0;
		end
		for i=1,n do
			-- Retrieve and define object names
			BARNAME=XCustomBarData["bar"..tostring(i)];
			XBARMOD="XCustomBar"..BARNAME;
			if XBarModData[XBARMOD]["enabled"] then
				XCustomBarResetSpellList(XBARMOD);
				XBar_Update(XBARMOD);
				XBar_Update(XBARMOD);
			end
		end
	elseif (event == "PLAYER_ENTERING_WORLD") and (not XCUSTOMBAR_LOADED) then
		-- Clean up old data
		if (XCustomBarData["queue"]) then
			DEFAULT_CHAT_FRAME:AddMessage(XCUSTOMBAR_MSG4);
			for i,b in pairs(XCustomBarData["queue"]) do
				-- If this is still an active bar, lets not delete it
				n=XCustomBarData["nbars"];
				f=false;
				for c=1,n do
					if (XCustomBarData["bar"..tostring(c)]==b) then
						f=true;
						break;
					end
				end
				if (not f) then
					n=XBarData["noptionsets"];
					if (n==nil) then
						break;
					end
					for c=1,n do
						f=XBarData["optionset"..tostring(c)];
						if (XBarData["optionset-"..f]) then
							XBarData["optionset-"..f]["mods"]["XCustomBar"..b]=nil;
							m=XBarData["optionset-"..f]["nmods"];
							for x=1,m do
								if (XBarData["optionset-"..f]["mod"..tostring(x)]=="XCustomBar"..b) then
									XBarData["optionset-"..f]["mod"..tostring(x)]=XBarData["optionset-"..f]["mod"..tostring(m)];
									XBarData["optionset-"..f]["mod"..tostring(m)]=nil;
									XBarData["optionset-"..f]["nmods"] = m-1;
									break;
								end
							end
						end	
					end
				end
			end
			if (n == nil) then
				DEFAULT_CHAT_FRAME:AddMessage(XCUSTOMBAR_MSG5);
			else
				XCustomBarData["queue"]=nil;
			end
		end

		-- Register mods with XBar
		n=XCustomBarData["nbars"];
		if (n==nil) then
			n=0;
		end
		-- Build the name in case it hasn't gotten around to it yet
		XBar_BuildPlayerName();
		for i=1,n do
			-- Retrieve and define object names
			BARNAME=XCustomBarData["bar"..tostring(i)];
			XBARMOD="XCustomBar"..BARNAME;
			XBar_RegisterAddon(XBARMOD);
			XBar_Update(XBARMOD);
		end
		DEFAULT_CHAT_FRAME:AddMessage(XCUSTOMBAR_MSG6..tostring(n)..XCUSTOMBAR_MSG7);
		XCUSTOMBAR_LOADED=true;
	end
end

function XCustomBar_OnEvent()
	local bn=this:GetName();
	local XBM = "XCustomBar"..XBarFrameDB[bn]["XCUSTOMBAR"];

	-- XBar has built in functionality to update its plugins
	if (event == "SPELLS_CHANGED") then
		XBar_Scale(XBM);
		XBar_Update(XBM);
	elseif (event == "SPELL_UPDATE_COOLDOWN" and getfenv()["XBarPlayerName"]) then
		XBar_UpdateCooldowns(XBM);
	elseif (event == "PLAYER_AURAS_CHANGED") then
		XBar_Update(XBM);
	elseif (event=="UPDATE_MACROS") then
		-- If we do something that affects macros, reset the spell list before updating
		XCustomBarResetSpellList(XBM);
		XBar_Update(XBM);
		XBar_Update(XBM);
	elseif (event == "ACTIONBAR_UPDATE_USABLE") then
		XBar_UpdateCooldowns(XBM);
	end
end

--[[Button string format:
	1 - Number of successive actions
	2 - Type of actions (S=Spell, M=Macro, I=Item)
	3 - Modifier:Shift (shift-)
	4 - Modifier:Ctrl (ctrl-)
	5 - Modifier:Alt (alt-)
	6 - Help/Harm (0=none, 1=help, 2=harm)
	7 - Button (1-5,*)
	8 - Start of name sequence up to '|', and next block begins with 3
]]--

function XCustomBar_Button(button,spellname,index)
	local pfn = button:GetParent():GetName();
	local fn = button:GetName();
	local BN = XBarFrameDB[pfn]["XCUSTOMBAR"];
	local XBM="XCustomBar"..BN;
	local def,nActions,bType,buf1,buf2,buf3,buf4,pos,x,bi,trash,id,_;

	trash=false; --  We'll use this to see if we need to trash this button.

	-- XBar won't tell us if it hid a button previously to this due to the fact that we had no spell for it, so we have to figure this out on our own.
	bi=XBarFrameDB[fn]["XBarVI"];
	if (bi==nil) then
		return;
	end

	def=XCustomBarData["bars"][BN]["button"..tostring(bi)];
	nActions=tonumber(strsub(def,1,1));
	bType=strsub(def,2,2);

	if XBarFrameDB[fn] == nil then
		XBarFrameDB[fn] = {};
	end

	def=strsub(def,3);
	if (bType=="I") then
		bType="item";
	elseif (bType=="M") then
		bType="macro";
	elseif (bType=="S") then
		bType="spell";
	end

	-- Clear default actions if not in combat (if we were in combat, the actions would have remained unchanged from last time)
	if (not InCombatLockdown()) then
		button:SetAttribute("button*",nil);
		button:SetAttribute("type",nil);
		button:SetAttribute("spell*",nil);
		button:SetAttribute("ctrl-spell*",nil);
	end

	for x=1,nActions do
		buf1="";
		-- Modifiers
		if (strsub(def,1,1)=="+") then
			buf1=buf1.."shift-";
		elseif (strsub(def,1,1)=="*") then
			buf1=buf1.."lshift-";
		elseif (strsub(def,1,1)=="%") then
			buf1=buf1.."rshift-";
		end
		if (strsub(def,2,2)=="+") then
			buf1=buf1.."ctrl-";
		elseif (strsub(def,2,2)=="*") then
			buf1=buf1.."lctrl-";
		elseif (strsub(def,2,2)=="%") then
			buf1=buf1.."rctrl-";
		end
		if (strsub(def,3,3)=="+") then
			buf1=buf1.."alt-";
		elseif (strsub(def,3,3)=="*") then
			buf1=buf1.."lalt-";
		elseif (strsub(def,3,3)=="%") then
			buf1=buf1.."ralt-";
		end

		-- Help/Harm
		if (strsub(def,4,4)=="1") then
			buf2="help";
		elseif (strsub(def,4,4)=="2") then
			buf2="harm";
		else
			buf2="";
		end
		-- Button identifier (1-5 or *)
		buf3=strsub(def,5,5);

		pos=strfind(def,"|",6);
		buf4=strsub(def,6,pos-1);
		if not InCombatLockdown() then
			button:RegisterForClicks("AnyUp");
			-- Update while not in combat
			if (buf2~="") then
				-- If using helpbutton or harmbutton then we must specify the button:
				--*** AUTO-SELF CAST WILL NOT WORK FOR THIS ***
				button:SetAttribute("*unit*","target");  -- Need to specify a unit for this to work.
				button:SetAttribute("*"..buf2.."button"..buf3,buf2.."ability"..buf3);
				button:SetAttribute("*".."type-"..buf2.."ability"..buf3,bType);
				button:SetAttribute(buf1..bType.."-"..buf2.."ability"..buf3,buf4);
			else
				-- When not using helpbutton or harmbutton, we build the button usage into type
				button:SetAttribute("button"..buf3,"type"..buf3);
				button:SetAttribute("type"..buf3,bType);
				button:SetAttribute(buf1..bType..buf3,buf4);
			end
		end
		if (pos==strlen(def)) then
			def="";
		else
			def=strsub(def,pos+1);
		end
	end

	-- Now lets put in our texture
	-- If it's a spell, use the built in spell tracking features for the last spell, otherwise, "break" the spell tracking
	-- For the item and Macro tooltips, we will pretend to be the toggle buttons and show some plain text
	buf1="Interface\\Icons\\INV_Misc_QuestionMark";
	if (bType=="item") then
		buf1 = GetItemIcon(buf4);
		XBarFrameDB[fn]["XBarID"]=nil;
		XBarFrameDB[fn]["XBarCD"]="I"..tostring(buf4);
		XBarFrameDB[fn]["XBarBT"]=nil;
		-- Put '-' in here so we still look like a toggle bar, but the main mover handler can still react appropriately
		XBarFrameDB[fn]["XBarToggle"]="-";
		XBarFrameDB[fn]["XBarInfoText"]=buf4;
		x=XCustomBarCountInventoryItems(buf4);

		if (x==0) then
			if (not InCombatLockdown()) or (InCombatLockdown() and (not XBarFrameDB[fn]["XBarItemUse"])) then
				XBarFrameDB[fn]["XBarItemUse"]=nil;
				trash=true;
				XBar_ShowCount(XBM,index,0);
			end
		else
			-- If this is equipped, lets show the user
			if XCustomBarInventoryEquip[buf4] then
				XCustomBarShowMacro(XBM,index,"E");
			else
				XBar_ShowCount(XBM,index,x);
			end
			-- Item detection to keep items around that we run out of in combat.
			if not InCombatLockdown() then
				if XBarFrameDB[fn]["XBarItemUse"]==nil then
					XBarFrameDB[fn]["XBarItemUse"]=true;
				end
			end
		end
	elseif (bType=="macro") then
		XBarFrameDB[fn]["XBarItemUse"]=nil;
		x=GetMacroIndexByName(buf4);
		_,buf1,buf3 = GetMacroInfo(x);
		XBarFrameDB[fn]["XBarID"]=nil;
		-- using the combat lockdown to throttle the calls to the cooldown extractor since its quite intense
		-- Meanwhile we have this stored in another variable to use in case.
		if InCombatLockdown() then
			XBarFrameDB[fn]["XBarCD"]=XBarFrameDB[fn]["XCustomBarCD"];
		else
			if buf3==nil then
				XBarFrameDB[fn]["XBarCD"]="SInil";
			else
				XBarFrameDB[fn]["XBarCD"]=XCustomBarExtractCooldown(buf3);
			end
		end
		XBarFrameDB[fn]["XCustomBarCD"]=XBarFrameDB[fn]["XBarCD"];
		XBarFrameDB[fn]["XBarBT"]=nil;
		-- Put '-' in here so we still look like a toggle bar, but the main mover handler can still react appropriately
		XBarFrameDB[fn]["XBarToggle"]="-";
		XBarFrameDB[fn]["XBarInfoText"]=buf4;
		if (GetMacroIndexByName(buf4)==0) then
			trash=true;
		end
		XCustomBarShowMacro(XBM,index,buf4);
	elseif (bType=="spell") then
		XBarFrameDB[fn]["XBarItemUse"]=nil;
		if (getfenv()[XBM.."Spells"][index] ~= buf4) then
			-- Update the default list if we need to for next time, the XBar_UpdateCooldown function will catch the texture update.
			getfenv()[XBM.."Spells"][index]=buf4;
			buf3=buf4;
			x=strfind(buf4,"(",1,true);
			if (x) then
				pos=strfind(buf4,")",x,true);
				if (pos) then
					buf3=strsub(buf4,1,x-1);
					buf2=strsub(buf4,x+1,pos-1);
				end
			else
				buf2=nil;
			end
			id = XBar_GetSpellID(buf3,XBarModData[XBM]["booktype"],buf2);
			XBarFrameDB[fn]["XBarID"]=id;
			XBarFrameDB[fn]["XBarCD"]="SI"..tostring(id);
			if (id==nil) then
				XBarFrameDB[fn]["XBarBT"]=nil;
				trash=true;
			else
				XBarFrameDB[fn]["XBarBT"]=XBarModData[XBM]["booktype"];
			end
			if IsConsumableSpell(buf3) then
				x=GetSpellCount(buf3);
				if x==nil then
					x=1;
				end
			else
			    x=1;
			end
			XBar_ShowCount(XBM,index,x);
		end
	end
	getfenv()[button:GetName().."Icon"]:SetTexture(buf1);
	XBarFrameDB[fn]["XBarTT"]=XBarData[getfenv()["XBarOptionSet"]]["mods"][XBM]["tooltips"];
	if (trash) then
		-- Get rid of the button, we don't need to show it
		getfenv()["XCustomBar"..BN.."Spells"][bi]="-";
	else
		getfenv()["XCustomBar"..BN.."Spells"][bi]="+";
	end
end

function XCustomBar_ButtonID(id,value)
	local rc;
	-- Trick the bar into thinking it has a spell by setting it to the first spell in the book, which obviously you have.
	-- If we specified not to show this button, then don't show it.

	rc=1;
	if (value=="-") then
		rc=nil;
	end

	return rc;
end

-- Securely hook to XBar_Scale and see if we're scaling a CustomBar.  If so, update it so the macro text will resize
hooksecurefunc("XBar_Scale",function ()
	local mod=XBarConfigCurMod:GetText();

	if (mod==nil) then
		return; -- Ignore me
	end

	if (strsub(mod,1,10) == "XCustomBar") then
		XBar_Update(mod);
	end
end
);

function XCustomBar_SlashHandler(msg)
	if (strfind(msg, "config")) then
		if(XCustomBarConfig:IsVisible()) then
			XCustomBarConfig:Hide();
		else
			XCustomBarConfig:Show();
		end
	else
		DEFAULT_CHAT_FRAME:AddMessage("XCustomBar v"..ver);
		DEFAULT_CHAT_FRAME:AddMessage(XBAR_HELPTEXT1);
		DEFAULT_CHAT_FRAME:AddMessage(XCUSTOMBAR_HELPTEXT2);
	end
end

function XCustomBarShowMacro(mod,index,n)
	local b=getfenv()[mod.."Button"..tostring(index).."Count"];
	local s,p,l,t;

	t=n;
	l=strlen(n);
	-- Sizing chart
	if (l>2) then
		s=XBarData[getfenv()["XBarOptionSet"]]["mods"][mod]["scale"];
		if (s > 2.4) then
			if (s > 3.15) then
				-- 3.20 - 4.0 = 5
				p=5;
			else
				-- 2.45 - 3.15 = 4
				p=4;
			end
		else
			-- 0.5 - 2.4 = 3
			p=3;
		end
		t=strsub(n,1,p);
	end
	b:SetText(t);
end

function XCustomBarExtractCooldown(macrotext)
	local p1,p2;
	local s=nil;
	local rc="SInil";
	local i=nil;
	-- Placeholder until we can parse the macros correctly.

	-- #Showtooltip
	p1=strfind(macrotext,"#showtooltip ",1,true);
	if (p1) then
		s=strsub(macrotext,p1+13);
		if (s) then
			p2=strfind(s,strchar(10),1,true);
			if (p2) then
				s=strsub(s,1,p2-1);
			else
				s=nil;
			end
		end
	else
		-- #Show
		p1=strfind(macrotext,"#show ",1,true);
		if (p1) then
			s=strsub(macrotext,p1+6);
			if (s) then
				p2=strfind(s,strchar(10),1,true);
				if (p2) then
					s=strsub(s,1,p2-1);
				else
					s=nil;
				end
			end
		else
			-- /cast /castsequence or /use
			p1=strfind(macrotext,"/castsequence",1,true);
			p2=14;
			if (not p1) then
				p1=strfind(macrotext,"/cast",1,true);
				p2=6;
			end
			if (not p1) then
				p1=strfind(macrotext,"/use",1,true);
				p2=5;
				i=true;
			end
			if (p1) then
				s=strsub(macrotext,p1+p2);
				if (s) then
					-- Lets strip out this line ahead of time
					p2=strfind(s,strchar(10),1,true);
					if (p2) then
						s=strsub(s,1,p2-1);
					end
					-- Could be multiple '[...]' or a 'reset=...' before spell
					while true do
						p2=strfind(s,"[",1,true);
						if (p2) then
							p2=strfind(s,"]",1,true);
							if not p2 then
								-- malformed
								rc="SInil";
								s="";
								break;
							else
								-- get rid of the []
								s=strsub(s,p2+1);
							end
						else
							p2=strfind(s,"reset=",1,true);
							if (p2) then
								p2=strfind(s," ",1,true);
								if not p2 then
									-- malformed
									rc="SInil";
									s="";
									break;
								else
									s=strsub(s,p2+1);
									break;  -- If we see reset, there can't be a [] after
								end
							elseif strsub(s,1,1)==" " then
								-- Trim up spaces
								s=strsub(s,2);
							else
								-- No [] or reset= or leading spaces left
								break;
							end
						end
					end

					-- Spell ender could be a ';' ',' or LF after spell
					-- LF was stripped out, so if we don't find a ; or , then we already have the name
					p2=strfind(s,";",1,true);
					if (not p2) then
						p2=strfind(s,",",1,true);
					end
					if (p2) then
						s=strsub(s,1,p2-1);
					end
				end
			else
				s="nil"; -- cannot determine the spell
			end
		end
	end

	if (not i) then
		rc="SN"..tostring(s);
	else
		rc="I"..s;
	end
	return rc;
end

-- SCROLL FRAME TEMPLATE FUNCTIONS --

function XCustomBarScrollFrameTemplate_OnScroll()
	local fn = this:GetParent():GetName();
	local f=XBarFrameDB[fn]["XBarOnScroll"];
	
	if (f) then
		-- Pass the function call along
		getfenv()[f]();
	end
end

function XCustomBarScrollFrameTemplate_OnClick(i)
	local fn = this:GetParent():GetName();
	local f=XBarFrameDB[fn]["XBarOnClick"];

	if (f) then
		-- Pass the function call along
		getfenv()[f](i);
	end
end

function XCustomBarScrollFrame_ClearHighlights(sFrame)
	local x,f;

	for x=1,10 do
		getfenv()[sFrame.."Line"..tostring(x)]:UnlockHighlight();
	end
end

function XCustomBarScrollFrame_Highlight(sFrame,index)
	if (index>=1) and (index<=10) then
		getfenv()[sFrame.."Line"..tostring(index)]:LockHighlight();
	end
end

-- CONFIG FUNCTIONS --

function XCustomBarConfig_OnShow()
	if (not XBarData) then
		this:Hide();
		return;
	end
	if (not XBarData[getfenv()["XBarOptionSet"]]) then
		this:Hide();
		return;
	end

	n=XBarData[getfenv()["XBarOptionSet"]]["nmods"];
	if (n==nil) then
		this:Hide();
		return;
	end

	XBarFrameDB["XCustomBarConfigScrollBars"]["XBarCur"]=nil;
	XBarFrameDB["XCustomBarConfigScrollButtons"]["XBarCur"]=nil;
	XBarFrameDB["XCustomBarConfigScrollActions"]["XBarCur"]=nil;
	
	securecall(XCustomBarConfigScrollBars_OnScroll);
	securecall(XCustomBarConfigScrollButtons_OnScroll);
	securecall(XCustomBarConfigScrollActions_OnScroll);

	XBarFrameDB["XCustomBarConfigNewButtonMenu"]={["XBarCur"]="S"};
	XCustomBarConfigNewButtonLabel:SetText(XCUSTOMBAR_LABELSPELL);
end

function XCustomBarConfigScrollBars_OnLoad()
	local bn=this:GetName();
	if XBarFrameDB[bn] == nil then
		XBarFrameDB[bn] = {};
	end
	XBarFrameDB[bn]["XBarOnScroll"]="XCustomBarConfigScrollBars_OnScroll";
	XBarFrameDB[bn]["XBarOnClick"]="XCustomBarConfigScrollBars_OnClick";
	securecall(XCustomBarConfigScrollBars_OnScroll);
end

function XCustomBarConfigScrollBars_OnScroll()
	local i,o,v,curi,curb,b,b2;

	if InCombatLockdown() then
		return;
	end
	
	curi,curb=XCustomBarCurBar();
	n=XCustomBarData["nbars"];
	if (n==nil) then
		n=0;
	end;
	o=FauxScrollFrame_GetOffset(XCustomBarConfigScrollBarsScrollFrame);
	for i=1,10 do
		v=i+o;
		b=getfenv()["XCustomBarConfigScrollBarsLine"..tostring(i)];
		b2=getfenv()["XCustomBarConfigScrollBarsLine"..tostring(i).."TextName"];
		if XBarFrameDB["XCustomBarConfigScrollBarsLine"..tostring(i)] == nil then
			XBarFrameDB["XCustomBarConfigScrollBarsLine"..tostring(i)] = {};
		end
		if (v>n) then
			b2:SetText("");
			XBarFrameDB["XCustomBarConfigScrollBarsLine"..tostring(i)]["XBarValue"]=nil;
			b:Hide();
		else
			b2:SetText(XCustomBarData["bar"..v]);
			XBarFrameDB["XCustomBarConfigScrollBarsLine"..tostring(i)]["XBarValue"]=v;
			b:Show();
		end
	end
	if (n <= 10) then
		-- Extra stuff, lets hide our glider textures
		XCustomBarConfigScrollBarsGliderBar1:Hide();
		XCustomBarConfigScrollBarsGliderBar2:Hide();
		XCustomBarConfigScrollBarsGliderBar3:Hide();
	else
		XCustomBarConfigScrollBarsGliderBar1:Show();
		XCustomBarConfigScrollBarsGliderBar2:Show();
		XCustomBarConfigScrollBarsGliderBar3:Show();
	end
	
	-- Update highlights
	XCustomBarScrollFrame_ClearHighlights("XCustomBarConfigScrollBars");
	if (curi) then
		XCustomBarScrollFrame_Highlight("XCustomBarConfigScrollBars",curi-o);
	end

	FauxScrollFrame_Update(XCustomBarConfigScrollBarsScrollFrame,n,10,16);
end

function XCustomBarConfigScrollBars_OnClick(iButton)
	local v;

	-- Update highlights
	XCustomBarScrollFrame_ClearHighlights("XCustomBarConfigScrollBars");
	XCustomBarScrollFrame_Highlight("XCustomBarConfigScrollBars",iButton);

	-- Bar selected, update window to reflect.
	v=XBarFrameDB["XCustomBarConfigScrollBarsLine"..tostring(iButton)]["XBarValue"];
	XBarFrameDB["XCustomBarConfigScrollBars"]["XBarCur"]=v;
	XBarFrameDB["XCustomBarConfigScrollButtons"]["XBarCur"]=nil;
	XBarFrameDB["XCustomBarConfigScrollActions"]["XBarCur"]=nil;
	securecall(XCustomBarConfigScrollButtons_OnScroll);
	securecall(XCustomBarConfigScrollActions_OnScroll);
end

function XCustomBarConfigNewBarBtn_Click()
	-- Quantify text
	local t1=XCustomBarConfigNewBar:GetText();
	local t2="";
	local i,l,c;

	if (t1==nil) then
		t1="";
	end

	l=strlen(t1);
	i=1;
	while (i<=l) do
		c=strsub(t1,i,i);

		-- Unicode detection
		if strfind(XCUSTOMBAR_UNICODEPREFIXES,c,1,true) then
			c=strsub(t1,i,i+1);
			i=i+1;
		end

		if strfind(XCUSTOMBAR_VALIDCHARS,c,1,true) then
			t2=t2..c;
		end
		i=i+1;
	end

	XCustomBarConfigNewBar:SetText(t2);

	-- Validate name
	if (strlen(t2)==0) then
		DEFAULT_CHAT_FRAME:AddMessage(XCUSTOMBAR_MSG2);
		return;
	end

	c=XCustomBarData["nbars"];
	for i=1,c do
		if (t2==XCustomBarData["bar"..tostring(i)]) then
			DEFAULT_CHAT_FRAME:AddMessage(XCUSTOMBAR_MSG3);
			return;
		end
	end

	-- Add new bars
	c=c+1;
	XCustomBarData["nbars"]=c;
	XCustomBarData["bar"..tostring(c)]=t2;
	XCustomBarData["bars"][t2]={
		["nbuttons"]=1,
		["button1"]="1S---0*"..XCUSTOMBAR_LABELSPELL.."|",
	};

	-- Update the list
	XBarFrameDB["XCustomBarConfigScrollBars"]["XBarCur"]=c;
	if (c>10) then
		c=c-10;
		FauxScrollFrame_SetOffset(XCustomBarConfigScrollBarsScrollFrame,c);
	end
	securecall(XCustomBarConfigScrollBars_OnScroll);
	XBarFrameDB["XCustomBarConfigScrollButtons"]["XBarCur"]=nil;
	XBarFrameDB["XCustomBarConfigScrollActions"]["XBarCur"]=nil;
	securecall(XCustomBarConfigScrollButtons_OnScroll);
	securecall(XCustomBarConfigScrollActions_OnScroll);
end

function XCustomBarConfigDelBarBtn_Click()
	local b,n;

	i,b,n=XCustomBarCurBar();
	n=XCustomBarData["nbars"];

	if (b==nil) then
		return;
	end

	-- Move bars up if needed
	for x=i,(n-1) do
		XCustomBarData["bar"..tostring(x)]=XCustomBarData["bar"..tostring(x+1)];
	end
	
	-- Delete last bar
	XCustomBarData["bar"..tostring(n)]=nil;
	XCustomBarData["bars"][b]=nil;
	n=n-1;
	XCustomBarData["nbars"]=n;

	--Queue the bar for cleanup next time the mod loads
	if (XCustomBarData["queue"]==nil) then
		XCustomBarData["queue"]={ };
	end
	tinsert(XCustomBarData["queue"],b);

	-- Update the list
	-- Only adjust offset if needed
	if (n==0) then
		XBarFrameDB["XCustomBarConfigScrollBars"]["XBarCur"]=nil;
	elseif (i>n) then
		XBarFrameDB["XCustomBarConfigScrollBars"]["XBarCur"]=n;
		if (n>10) then
			n=n-10;
			FauxScrollFrame_SetOffset(XCustomBarConfigScrollBarsScrollFrame,n);
		else
			FauxScrollFrame_SetOffset(XCustomBarConfigScrollBarsScrollFrame,0);
		end
	end
	securecall(XCustomBarConfigScrollBars_OnScroll);
	XBarFrameDB["XCustomBarConfigScrollButtons"]["XBarCur"]=nil;
	XBarFrameDB["XCustomBarConfigScrollActions"]["XBarCur"]=nil;
	securecall(XCustomBarConfigScrollButtons_OnScroll);
	securecall(XCustomBarConfigScrollActions_OnScroll);
end

function XCustomBarConfigScrollButtons_OnLoad()
	local bn=this:GetName();
	if XBarFrameDB[bn] == nil then
		XBarFrameDB[bn] = {};
	end
	XBarFrameDB[bn]["XBarOnScroll"]="XCustomBarConfigScrollButtons_OnScroll";
	XBarFrameDB[bn]["XBarOnClick"]="XCustomBarConfigScrollButtons_OnClick";
	securecall(XCustomBarConfigScrollButtons_OnScroll);
end

function XCustomBarConfigScrollButtons_OnScroll()
	local i,o,v,curbar,n,curbtn,_,b,b2;

	if InCombatLockdown() then
		return;
	end
	
	_,curbar,n=XCustomBarCurBar();
	curbtn=XCustomBarCurButton();
	o=FauxScrollFrame_GetOffset(XCustomBarConfigScrollButtonsScrollFrame);
	for i=1,10 do
		v=i+o;
		b=getfenv()["XCustomBarConfigScrollButtonsLine"..tostring(i)]
		b2=getfenv()["XCustomBarConfigScrollButtonsLine"..tostring(i).."TextName"];
		if XBarFrameDB["XCustomBarConfigScrollButtonsLine"..tostring(i)] == nil then
			XBarFrameDB["XCustomBarConfigScrollButtonsLine"..tostring(i)] = {};
		end
		if (v>n) then
			b2:SetText("");
			XBarFrameDB["XCustomBarConfigScrollButtonsLine"..tostring(i)]["XBarValue"]=nil;
			b:Hide();
		else
			b2:SetText("Button "..v);
			XBarFrameDB["XCustomBarConfigScrollButtonsLine"..tostring(i)]["XBarValue"]=v;
			b:Show();
		end
	end
	if (n <= 10) then
		-- Extra stuff, lets hide our glider textures
		XCustomBarConfigScrollButtonsGliderBar1:Hide();
		XCustomBarConfigScrollButtonsGliderBar2:Hide();
		XCustomBarConfigScrollButtonsGliderBar3:Hide();
	else
		XCustomBarConfigScrollButtonsGliderBar1:Show();
		XCustomBarConfigScrollButtonsGliderBar2:Show();
		XCustomBarConfigScrollButtonsGliderBar3:Show();
	end
	
	-- Update highlights
	XCustomBarScrollFrame_ClearHighlights("XCustomBarConfigScrollButtons");
	if (curbtn) then
		XCustomBarScrollFrame_Highlight("XCustomBarConfigScrollButtons",curbtn-o);
	end

	FauxScrollFrame_Update(XCustomBarConfigScrollButtonsScrollFrame,n,10,16);
end

function XCustomBarConfigScrollButtons_OnClick(iButton)
	-- Update highlights
	XCustomBarScrollFrame_ClearHighlights("XCustomBarConfigScrollButtons");
	XCustomBarScrollFrame_Highlight("XCustomBarConfigScrollButtons",iButton);

	-- Bar selected, update window to reflect.
	XBarFrameDB["XCustomBarConfigScrollButtons"]["XBarCur"]=XBarFrameDB["XCustomBarConfigScrollButtonsLine"..iButton]["XBarValue"];
	XBarFrameDB["XCustomBarConfigScrollActions"]["XBarCur"]=nil;
	securecall(XCustomBarConfigScrollActions_OnScroll);
	securecall(XCustomBarConfigScrollActions_OnClick,1);
end

function XCustomBarConfigNewButtonBtn_Click()
	local t=XBarFrameDB["XCustomBarConfigNewButtonMenu"]["XBarCur"];
	local i,b,n;
	
	i,b,n=XCustomBarCurBar();

	if (b==nil) then
		return;
	end

	-- Add new button
	n=n+1;
	XCustomBarData["bars"][b]["nbuttons"]=n;
	if (t=="S") then
		t="1S---0*"..XCUSTOMBAR_LABELSPELL.."|";
	elseif (t=="M") then
		t="1M---0*"..XCUSTOMBAR_LABELMACRO.."|";
	elseif (t=="I") then
		t="1I---0*"..XCUSTOMBAR_LABELITEM.."|"
	end
	XCustomBarData["bars"][b]["button"..tostring(n)]=t;

	-- Update the list
	XBarFrameDB["XCustomBarConfigScrollButtons"]["XBarCur"]=n;
	if (n>10) then
		n=n-10;
		FauxScrollFrame_SetOffset(XCustomBarConfigScrollButtonsScrollFrame,n);
	end
	securecall(XCustomBarConfigScrollButtons_OnScroll);
	XBarFrameDB["XCustomBarConfigScrollActions"]["XBarCur"]=nil;
	securecall(XCustomBarConfigScrollActions_OnScroll);
end

function XCustomBarConfigDelButtonBtn_Click()
	local t=XBarFrameDB["XCustomBarConfigNewButtonMenu"]["XBarCur"];
	local i,b,n,x,c;

	i,b,n=XCustomBarCurBar();
	c=XCustomBarCurButton();

	if ((b==nil) or (n==1) or (c==nil)) then
		return;
	end

	-- Move buttons up if needed
	for x=c,(n-1) do
		XCustomBarData["bars"][b]["button"..tostring(x)]=XCustomBarData["bars"][b]["button"..tostring(x+1)];
	end
	
	-- Delete current button
	XCustomBarData["bars"][b]["button"..tostring(n)]=nil;
	n=n-1;
	XCustomBarData["bars"][b]["nbuttons"]=n;

	-- Update the list
	-- Only adjust offset if needed
	if (c>n) then
		XBarFrameDB["XCustomBarConfigScrollButtons"]["XBarCur"]=n;
		if (n>10) then
			n=n-10;
			FauxScrollFrame_SetOffset(XCustomBarConfigScrollButtonsScrollFrame,n);
		else
			FauxScrollFrame_SetOffset(XCustomBarConfigScrollButtonsScrollFrame,0);
		end
	end
	securecall(XCustomBarConfigScrollButtons_OnScroll);
	XBarFrameDB["XCustomBarConfigScrollActions"]["XBarCur"]=nil;
	securecall(XCustomBarConfigScrollActions_OnScroll);
end

function XCustomBarConfigScrollActions_OnLoad()
	local bn=this:GetName();
	if XBarFrameDB[bn] == nil then
		XBarFrameDB[bn] = {};
	end
	XBarFrameDB[bn]["XBarOnScroll"]="XCustomBarConfigScrollActions_OnScroll";
	XBarFrameDB[bn]["XBarOnClick"]="XCustomBarConfigScrollActions_OnClick";
	securecall(XCustomBarConfigScrollActions_OnScroll);
end

function XCustomBarConfigScrollActions_OnScroll()
	local i,o,v,curbar,curbtn,n,curact,curbtn,_,b,b2;

	if InCombatLockdown() then
		return;
	end

	_,curbar=XCustomBarCurBar();
	curbtn=XCustomBarCurButton();
	curact=XCustomBarCurAction();
	if (curbar==nil) or (curbtn==nil) then
		n=0;
	else
		n=XCustomBarData["bars"][curbar]["button"..tostring(curbtn)];
	end
	if (n==nil) then
		n=0;
	elseif (n=="") then
		n=0;
	else
		n=tonumber(strsub(n,1,1));
	end

	o=FauxScrollFrame_GetOffset(XCustomBarConfigScrollActionsScrollFrame);
	for i=1,10 do
		v=i+o;
		b=getfenv()["XCustomBarConfigScrollActionsLine"..tostring(i)]
		b2=getfenv()["XCustomBarConfigScrollActionsLine"..tostring(i).."TextName"];
		if XBarFrameDB["XCustomBarConfigScrollActionsLine"..tostring(i)] == nil then
			XBarFrameDB["XCustomBarConfigScrollActionsLine"..tostring(i)] = {};
		end
		if (v>n) then
			b2:SetText("");
			XBarFrameDB["XCustomBarConfigScrollActionsLine"..tostring(i)]["XBarValue"]=nil;
			b:Hide();
		else
			b2:SetText("Action"..v);
			XBarFrameDB["XCustomBarConfigScrollActionsLine"..tostring(i)]["XBarValue"]=v;
			b:Show();
		end
	end
	if (n <= 10) then
		-- Extra stuff, lets hide our glider textures
		XCustomBarConfigScrollActionsGliderBar1:Hide();
		XCustomBarConfigScrollActionsGliderBar2:Hide();
		XCustomBarConfigScrollActionsGliderBar3:Hide();
	else
		XCustomBarConfigScrollActionsGliderBar1:Show();
		XCustomBarConfigScrollActionsGliderBar2:Show();
		XCustomBarConfigScrollActionsGliderBar3:Show();
	end
	
	-- Update highlights
	XCustomBarScrollFrame_ClearHighlights("XCustomBarConfigScrollActions");
	if (curact) then
		XCustomBarScrollFrame_Highlight("XCustomBarConfigScrollActions",curact-o);
		if (getfenv()["XCustomBarConfigActionMenu"] ~= nil) then
			XCustomBarConfigActionMenu:Enable();
			XCustomBarConfigActionLabel:Show();
			XCustomBarConfigActionText:Show();
			XCustomBarConfigActionSave:Show();
			i,v=XCustomBarGetAction(curbar,curbtn,curact);
			if (i=="S") then
				XCustomBarConfigActionLabel:SetText(XCUSTOMBAR_LABELSPELL);
			elseif (i=="M") then
				XCustomBarConfigActionLabel:SetText(XCUSTOMBAR_LABELMACRO);
			elseif (i=="I") then
				XCustomBarConfigActionLabel:SetText(XCUSTOMBAR_LABELITEM);
			end
			XCustomBarConfigActionText:SetText(strsub(v,6));
		end
	else
		-- Nothing highlighted, lets disable the options
		if (getfenv()["XCustomBarConfigActionMenu"] ~= nil) then
			XCustomBarConfigActionMenu:Disable();
			XCustomBarConfigActionLabel:Hide();
			XCustomBarConfigActionText:Hide();
			XCustomBarConfigActionSave:Hide();
		end
	end

	FauxScrollFrame_Update(XCustomBarConfigScrollActionsScrollFrame,n,10,16);
end

function XCustomBarConfigScrollActions_OnClick(iButton)
	-- Bar selected, update window to reflect.
	XBarFrameDB["XCustomBarConfigScrollActions"]["XBarCur"]=XBarFrameDB["XCustomBarConfigScrollActionsLine"..iButton]["XBarValue"];

	-- Update highlights and action related options by updating the list.
	securecall(XCustomBarConfigScrollActions_OnScroll);
end

function XCustomBarConfigNewActionBtn_Click()
	local _,b,n,btn,t,s;
	
	_,b,n=XCustomBarCurBar();
	btn=XCustomBarCurButton();

	if ((b==nil) or (btn==nil)) then
		return;
	end

	s=XCustomBarData["bars"][b]["button"..tostring(btn)];
	n=tonumber(strsub(s,1,1));
	t=strsub(s,2,2);

	if (n>=9) then
		return;
	end

	-- Add new action
	n=n+1;
	s=XCustomBarStrReplace(s,1,1,tostring(n));
	if (t=="S") then
		t="---0*"..XCUSTOMBAR_LABELSPELL.."|";
	elseif (t=="M") then
		t="---0*"..XCUSTOMBAR_LABELMACRO.."|";
	elseif (t=="I") then
		t="---0*"..XCUSTOMBAR_LABELITEM.."|"
	end
	XCustomBarData["bars"][b]["button"..tostring(btn)]=s..t;

	-- Update the list
	XBarFrameDB["XCustomBarConfigScrollActions"]["XBarCur"]=n;
	if (n>10) then
		n=n-10;
		FauxScrollFrame_SetOffset(XCustomBarConfigScrollActionsScrollFrame,n);
	end
	securecall(XCustomBarConfigScrollActions_OnScroll);
end

function XCustomBarConfigDelActionBtn_Click()
	local _,b,n,btn,t,s,a,p1,p2,c;

	_,b,n=XCustomBarCurBar();
	btn=XCustomBarCurButton();
	c=XCustomBarCurAction();

	if ((b==nil) or (btn==nil) or (c==nil)) then
		return;
	end

	s=XCustomBarData["bars"][b]["button"..tostring(btn)];
	n=tonumber(strsub(s,1,1));
	t=strsub(s,2,2);

	if (n==1) then
		return;
	end

	t,a,p1,p2=XCustomBarGetAction(b,btn,c)

	-- Delete selected action
	n=n-1;
	s=XCustomBarStrReplace(s,1,1,tostring(n));
	s=XCustomBarStrReplace(s,p1,p2+1,"");
	XCustomBarData["bars"][b]["button"..tostring(btn)]=s;

	-- Update the list
	-- Only adjust offset if needed
	-- This code is redundant and unnecessary since the current limit on actions per button is 9.  I'm leaving it in for the future if I expand the list.
	if (c>n) then
		XBarFrameDB["XCustomBarConfigScrollActions"]["XBarCur"]=n;
		if (n>10) then
			n=n-10;
			FauxScrollFrame_SetOffset(XCustomBarConfigScrollActionsScrollFrame,n);
		else
			FauxScrollFrame_SetOffset(XCustomBarConfigScrollActionsScrollFrame,0);
		end
	end
	securecall(XCustomBarConfigScrollActions_OnScroll);
end

function XCustomBarCurBar()
	local curi=XBarFrameDB["XCustomBarConfigScrollBars"]["XBarCur"];
	local curb=nil;
	local curnb=0;
	
	if (curi ~= nil) then
		curb=XCustomBarData["bar"..tostring(curi)];
	end
	
	if (curb ~= nil) then
		curnb=XCustomBarData["bars"][curb]["nbuttons"];
	end
	if (curnb==nil) then
		curnb=0;
	end;

	return curi,curb,curnb;
end

function XCustomBarCurButton()
	return XBarFrameDB["XCustomBarConfigScrollButtons"]["XBarCur"];
end

function XCustomBarCurAction()
	return XBarFrameDB["XCustomBarConfigScrollActions"]["XBarCur"];
end

function XCustomBarGetAction(curbar, curbtn, curact)
	-- Returns: type (S/M/I), Actiontext (minus the ending '|'), startpos, endpos (relative to button string)
	local r=nil;
	local t=nil;
	local s,n,p,i,x,l;

	if ((curbar ~= nil) and (curbtn ~= nil) and (curact ~= nil)) then
		s=XCustomBarData["bars"][curbar]["button"..tostring(curbtn)];
	end

	if (s~=nil) then
		n=tonumber(strsub(s,1,1));
		t=strsub(s,2,2);
		l=strlen(s);
		if (curact <= n) then
			x=3;
			i=1;
			while (x<l) do
				p=strfind(s,"|",x);
				if (curact==i) then
					r=strsub(s,x,p-1);
					break;
				end
				i=i+1;
				x=p+1;
			end
		end
	end

	if (r==nil) then
		x=0;
		p=0;
	else
		p=p-1;
	end
	
	return t,r,x,p;
end

function XCustomBarStrReplace(s1,p1,p2,s2)
	local b1="";
	local b2="";
	local l=strlen(s1);

	if (p1>1) then
		b1=strsub(s1,1,p1-1);
	end
	if (p2<l) then
		b2=strsub(s1,p2+1);
	end
	b1=b1..s2..b2;
	
	return b1;
end

function XCustomBarConfigActionMenu_Select()
	local v=this.value;
	local s,t,curbar,curbtn,curact,p1,p2,a,f,v2;
	
	t=strsub(v,1,1);
	if (strlen(v)==3) then
		v2=strsub(v,3,3);
		if (v2=="L") then
			v2="*";
		elseif (v2=="R") then
			v2="%";
		else
			v2="+";
		end
	else
		v2="+";
	end
	v=strsub(v,2,2);

	_,curbar=XCustomBarCurBar();
	curbtn=XCustomBarCurButton();
	curact=XCustomBarCurAction();
	_,a,p1,p2=XCustomBarGetAction(curbar,curbtn,curact);
	if (a=="") then
		return;
	end

	s=XCustomBarData["bars"][curbar]["button"..tostring(curbtn)];
	if (t=="M") then
		if (v=="C") then
			p1=p1+1;
		elseif (v=="A") then
			p1=p1+2;
		end
		f=strsub(s,p1,p1);
		if (f ~= v2) then
			s=XCustomBarStrReplace(s,p1,p1,v2);
		elseif (f==v2) then
			s=XCustomBarStrReplace(s,p1,p1,"-");
		end
	elseif (t=="F") then
		s=XCustomBarStrReplace(s,p1+3,p1+3,v);
	elseif (t=="B") then
		s=XCustomBarStrReplace(s,p1+4,p1+4,v);
	end
	XCustomBarData["bars"][curbar]["button"..tostring(curbtn)]=s;
end

function XCustomBarConfigActionMenuFrame_OnLoad(menuframe,level)
	-- Loading off the click event from the button itself so we can make sure the data is there.
	-- Reinitializes every time we click the button.
	local info = UIDropDownMenu_CreateInfo();
	local i,t,v,c,c2,s,k,curbar,curbtn,curact;
	local menukey=UIDROPDOWNMENU_MENU_VALUE;

	level = level or 1;
	for i=1,15 do
		t=XCustomBarActionMenuData[i]["text"];
		v=XCustomBarActionMenuData[i]["value"];
		if (v==nil) then
			k=t;
		end
		if ((level==1) and (v==nil)) then
			info.text = t;
			info.func = nil;
			info.owner = this:GetParent();
			info.hasArrow=true;
			info.notCheckable=true;
			info.value=t;
			info.checked=false;
			UIDropDownMenu_AddButton(info,1);
		elseif ((level==2) and (v~=nil) and (menukey==k)) then
			info.text = t;
			info.func = XCustomBarConfigActionMenu_Select;
			info.owner = this:GetParent();
			info.hasArrow=false;
			info.notCheckable=false;
			info.value=v;
			info.checked=false;
			t=strsub(v,1,1);
			c=strsub(v,2,2);
			c2="";
			if (strlen(v)==3) then
				c2=strsub(v,3,3);
			end
			_,curbar=XCustomBarCurBar();
			curbtn=XCustomBarCurButton();
			curact=XCustomBarCurAction();
			_,s=XCustomBarGetAction(curbar,curbtn,curact);
			if  ((t=="M") and (c=="S") and (c2=="") and (strsub(s,1,1)=="+")) or
			    ((t=="M") and (c=="S") and (c2=="L") and (strsub(s,1,1)=="*")) or
			    ((t=="M") and (c=="S") and (c2=="R") and (strsub(s,1,1)=="%")) or
				((t=="M") and (c=="C") and (c2=="") and (strsub(s,2,2)=="+")) or
			    ((t=="M") and (c=="C") and (c2=="L") and (strsub(s,2,2)=="*")) or
			    ((t=="M") and (c=="C") and (c2=="R") and (strsub(s,2,2)=="%")) or
				((t=="M") and (c=="A") and (c2=="") and (strsub(s,3,3)=="+")) or
			    ((t=="M") and (c=="A") and (c2=="L") and (strsub(s,3,3)=="*")) or
			    ((t=="M") and (c=="A") and (c2=="R") and (strsub(s,3,3)=="%")) or
				((t=="F") and (c==strsub(s,4,4))) or
				((t=="B") and (c==strsub(s,5,5))) then
				info.checked=true;
			end
			UIDropDownMenu_AddButton(info,2);
		end
	end
end

function XCustomBarConfigActionMenu_OnClick()
	UIDropDownMenu_Initialize(XCustomBarConfigActionMenuFrame, XCustomBarConfigActionMenuFrame_OnLoad);
	ToggleDropDownMenu(1, nil, XCustomBarConfigActionMenuFrame, XCustomBarConfigActionMenu, 0, 0);
end

function XCustomBarConfigActionSave_OnClick()
	local t1=XCustomBarConfigActionText:GetText();
	local t2="";
	local i,l,c,b,n,btn,a,p1,p1,s;

	_,b,n=XCustomBarCurBar();
	btn=XCustomBarCurButton();
	a=XCustomBarCurAction();

	if ((b==nil) or (btn==nil) or (a==nil)) then
		return;
	end

	if (t1==nil) then
		t1="";
	end

	l=strlen(t1);
	i=1;
	while (i<=l) do
		c=strsub(t1,i,i);

		-- Unicode detection
		if strfind(XCUSTOMBAR_UNICODEPREFIXES,c,1,true) then
			c=strsub(t1,i,i+1);
			i=i+1;
		end

		-- can't use Pipe char "|" under any circumstances
		if ((strfind(XCUSTOMBAR_VALIDCHARS,c,1,true) or strfind(XCUSTOMBAR_LIMITEDCHARS,c,1,true)) and (c~="|")) then
			t2=t2..c;
		end
		i=i+1;
	end

	XCustomBarConfigActionText:SetText(t2);

	-- Validate name
	if (strlen(t2)==0) then
		DEFAULT_CHAT_FRAME:AddMessage(XCUSTOMBAR_MSG2);
		return;
	end

	i,t1,p1,p2=XCustomBarGetAction(b,btn,a);
	s=XCustomBarData["bars"][b]["button"..tostring(btn)];
	XCustomBarData["bars"][b]["button"..tostring(btn)]=XCustomBarStrReplace(s,p1+5,p2,t2);
end

function XCustomBarConfigNewButtonMenu_Select()
	local v=this.value;

	if (v=="S") then
		XCustomBarConfigNewButtonLabel:SetText(XCUSTOMBAR_LABELSPELL);
	elseif (v=="M") then
		XCustomBarConfigNewButtonLabel:SetText(XCUSTOMBAR_LABELMACRO);
	elseif (v=="I") then
		XCustomBarConfigNewButtonLabel:SetText(XCUSTOMBAR_LABELITEM);
	end
	XBarFrameDB["XCustomBarConfigNewButtonMenu"]["XBarCur"]=v;
end

function XCustomBarConfigNewButtonMenuFrame_OnLoad(menuframe,level)
	-- Loading off the click event from the button itself so we can make sure the data is there.
	-- Reinitializes every time we click the button.
	local info = UIDropDownMenu_CreateInfo();

	info.func = XCustomBarConfigNewButtonMenu_Select;
	info.owner = this:GetParent();
	info.hasArrow=false;
	info.notCheckable=true;

	info.text = XCUSTOMBAR_LABELSPELL;
	info.value="S";
	UIDropDownMenu_AddButton(info,1);

	info.text = XCUSTOMBAR_LABELMACRO;
	info.value="M";
	UIDropDownMenu_AddButton(info,1);

	info.text = XCUSTOMBAR_LABELITEM;
	info.value="I";
	UIDropDownMenu_AddButton(info,1);
end

function XCustomBarConfigNewButtonMenu_OnClick()
	UIDropDownMenu_Initialize(XCustomBarConfigNewButtonMenuFrame, XCustomBarConfigNewButtonMenuFrame_OnLoad);
	ToggleDropDownMenu(1, nil, XCustomBarConfigNewButtonMenuFrame, XCustomBarConfigNewButtonMenu, 0, 0);
end

function XCustomBarConfigButtonMoveUp_OnClick()
	local _,b,n,btn,c,s;
	
	_,b,n=XCustomBarCurBar();
	btn=XCustomBarCurButton();

	if ((b==nil) or (btn==nil)) then
		return;
	end
	
	if (btn > 1) then
		c=btn-1;
		s=XCustomBarData["bars"][b]["button"..tostring(btn)];
		XCustomBarData["bars"][b]["button"..tostring(btn)]=XCustomBarData["bars"][b]["button"..tostring(c)];
		XCustomBarData["bars"][b]["button"..tostring(c)]=s;
		XBarFrameDB["XCustomBarConfigScrollButtons"]["XBarCur"]=c;
		s=FauxScrollFrame_GetOffset(XCustomBarConfigScrollButtonsScrollFrame);
		if (c==s) then
			s=s-1;
			FauxScrollFrame_SetOffset(XCustomBarConfigScrollButtonsScrollFrame,s);
		end
		securecall(XCustomBarConfigScrollButtons_OnScroll);
	end
end

function XCustomBarConfigButtonMoveDown_OnClick()
	local _,b,n,btn,s,c;
	
	_,b,n=XCustomBarCurBar();
	btn=XCustomBarCurButton();

	if ((b==nil) or (btn==nil)) then
		return;
	end
	
	if (btn < n) then
		c=btn+1;
		s=XCustomBarData["bars"][b]["button"..tostring(btn)];
		XCustomBarData["bars"][b]["button"..tostring(btn)]=XCustomBarData["bars"][b]["button"..tostring(c)];
		XCustomBarData["bars"][b]["button"..tostring(c)]=s;
		XBarFrameDB["XCustomBarConfigScrollButtons"]["XBarCur"]=c;
		if c>10 then
			c=c-10;
			FauxScrollFrame_SetOffset(XCustomBarConfigScrollButtonsScrollFrame,c);
		end
		securecall(XCustomBarConfigScrollButtons_OnScroll);
	end
end

function XCustomBarCountInventoryItems(itemname)
	local c;
	
	c=XCustomBarInventoryCount[itemname];
	if c==nil then
		c=0;
	end
	return c;
end

function XCustomBarResetSpellList(XBM)
	local key,value;
	local spelllist=getfenv()[XBM.."Spells"];
	
	for key,value in pairs(spelllist) do
		spelllist[key]="+";
	end
end

function XCustomBarUpdateInventory()
	local nslots,b,s,n,c,r,_,i,p;

	XCustomBarInventoryCount={}; -- Clear it out
	XCustomBarInventoryEquip={}; -- Clear it out
	
	for b=0,4 do
		nslots=GetContainerNumSlots(b);
		for s=1,nslots do
			_,c=GetContainerItemInfo(b,s);
			n=GetContainerItemLink(b,s);
			if (n) then
				p=strfind(n,"[",1,true);
				if (p) then
					itemname=strsub(n,p+1,-6)
					r=XCustomBarInventoryCount[itemname];
					if (r==nil) then
						r=0;
					end
					XCustomBarInventoryCount[itemname]=r+c;
				end
			end
		end
	end

	-- Now check to see if they're wearing it
	for b=0,23 do
		n=GetInventoryItemLink("player",b);
		if (n) then
			p=strfind(n,"[",1,true);
			if (p) then
				itemname=strsub(n,p+1,-6)
				r=XCustomBarInventoryCount[itemname];
				if (r==nil) then
					r=0;
				end
				XCustomBarInventoryCount[itemname]=r+1;
				XCustomBarInventoryEquip[itemname]=true;
			end
		end
	end
end
